jaf={}
jaf.error_detect_text={}
jaf.error_detect_stat=true
jaf.error_detect_limit=200 --- many errors could be saved

function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end

function jaf.checkerror_count()
         c=0
         while jaf.error_detect_text[c]~=nil do
               c=c+1
         end
         return c
end

function jaf.checkerror_get(errormsg)
         c=0
         while jaf.error_detect_text[c]~=nil do
               c=c+1
         end
         jaf.error_detect_text[c]=errormsg
end

function jaf.checkerror_getshow()
         txt,c={},jaf.checkerror_count()
         if c>1 then
            for i=1,c do
                txt[i]=jaf.error_detect_text[i]
            end
            return txt
         else
            return false
         end
end

function jaf.checkserver_luaerror()
         jaf.error_detect_stat=false
         c=jaf.checkerror_count()
         if c<10 then
            print("\169000555000Your server is normal, there are "..c.." lua error(s)")
         elseif c<50 then
            print("\169000555000Your server is not normal, there are "..c.." lua errors")
         elseif c<100 then
            print("\169000555000Your server is sick, there are "..c.." lua errors")
         elseif c<150 then
            print("\169000555000Your server is going to dead, there are "..c.." lua errors")
         else
            print("\169000555000Your server is will crashed, there are "..c.."++ lua errors")
         end
         jaf.checkerror_modus()
         jaf.error_detect_stat=true
end

function jaf.checkerror_vartable(tbl,txt)
         if tbl and #tbl>0 then
            for i=0,#tbl do
                if tbl[i] and tbl[i]==txt then
                   return {true,i}
                 end
            end
         end
         return {false,0}
end

function jaf.checkerror_modus()
         jaf.error_detect_stat=false
         c=jaf.checkerror_count()
         getm,getm2,k,getmc={},{},0,{}
         for i=0,c do
             v=jaf.checkerror_vartable(getm,jaf.error_detect_text[i])
             if v[1]==false then
                k=k+1
                getm[k]=jaf.error_detect_text[i]
                getmc[k]=1
                getm2[k]={}
             elseif v[1] then
                getmc[v[2]]=getmc[v[2]]+1
                getm2[v[2]][getmc[v[2]]]=jaf.error_detect_text[i]
             end
         end
         if getm and #getm>0 then
            hrm,srm=0,0
            for i=0,#getm do
                if getm2[i] and getmc[i]>srm then
                   hrm=i
                   srm=getmc[i]
                end 
            end
            print("\169255255255There are many Errors("..srm..") of:")
            if getm[hrm] then print("\169255255255"..getm[hrm]) end
         end
         jaf.error_detect_stat=true
         return {error=getm,errorc=getmc,count=k}
end

addhook("log","jaf.log")
function jaf.log(t)
         if string.lower(totable(t)[1])=="lua" and string.find(string.lower(t),"lua error:") and jaf.error_detect_stat and jaf.checkerror_count()<jaf.error_detect_limit then
            jaf.checkerror_get(t)
         end
end

addhook("parse","jaf.parse")
function jaf.parse(cmd)
        _msg=totable(cmd)
        msg_cmd=tostring(_msg[1])
        if msg_cmd=="serverstat" then
                jaf.checkserver_luaerror()
                return 2
        elseif msg_cmd=="listerror" then
                v=jaf.checkerror_modus()
                jaf.error_detect_stat=false
                print("\169000555000List of error:")
                if v.count>0 then
                    for i=1,#v.error do
                        print("\169255255000("..v.errorc[i].." errors) "..v.error[i])
                    end
                end
                jaf.error_detect_stat=true
                return 2
        end
end